const async = require("async");
const logger = require("ponthos-logger").logger(__filename);

function WorkFlow(newTasks = []) {
  this.tasks = newTasks;
}

WorkFlow.prototype.addTasks = function(newTasks) {
  this.tasks = [...this.tasks, ...newTasks];
};

WorkFlow.prototype.entry = function(data, callback) {
  const numOfTaks = this.tasks.length;
  if (numOfTaks == 0) {
    throw new Error("A Flow must have at least 1 task");
  }
  const [firstTask, ...otherTasks] = this.tasks;

  async.waterfall([async.apply(firstTask, data), ...otherTasks], callback);
};

// WorkFlow.prototype.entry = function(data, callback) {
//   async.parallelLimit([async.apply(this.worker, data)], /* config.rest.max_callers */ 1, function (err, result) {
//     if (err) logger.error('out:' + JSON.stringify(err));
//     else logger.debug('out:' + JSON.stringify(result[0]));
//     callback(err, result[0]);
//   });
// };

// module.exports = {
//   entry,
//   addTasks
// };

module.exports = WorkFlow;
