const async = require("async");
const util = require("util");

const Validator = require("./validation/methods");
const Business = require("./business");

const loaders = [];
let globalConfig;

const Load = util.promisify(callback => {
  async.series(loaders.map(l => l.bind(null, globalConfig)), (err, result) => {
    if (err) {
      console.error(
        util.format("Something went wrong in booting time (%s)", err)
      );

      callback(err);
      // logger.error(util.format('Something went wrong in booting time (%s)', err));
      // process.exit(1);
    } else {
      console.info(
        `Server started at ports ['${globalConfig.app.http}, ${
          globalConfig.app.https
        }]`
      );
      callback(null, true);
      // logger.info(`Server started at ports ['${config.app.http}, ${config.app.https}]`);
      started = true;
    }
  });
});

module.exports = {
  Validator,
  Business,
  Load,
  Loaders: loaders,
  get config() {
    return globalConfig;
  },
  set config(config) {
    globalConfig = config;
  }
};
